import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;

 class spriteview extends Frame
{
static spriteview f;
static int facing = 1;
Toolkit toolkit = Toolkit.getDefaultToolkit();
static Image player_image[] = new Image[8];
static int pos_x = 100, pos_y = 100, window_bounds_x = 200, window_bounds_y = 200, step_size = 15;
boolean loadedgraphics = false, game = true;
PlayerActor player_icon;
Thread T;
int FPS = 85;
// TEMP VAR
int keeptime = 0;
///
SpriteCanvas SC;
static String net_mode, net_ip, net_port;

public spriteview()
	{
	setTitle("SpriteView");
	setBackground (new Color(255,226,197));
	setLayout(new BorderLayout());
SC = new SpriteCanvas(this);
//player_icon = new PlayerActor(f);
//player_icon.start();

player_image[0] = toolkit.getImage("1.gif");
player_image[1] = toolkit.getImage("2.gif");
player_image[2] = toolkit.getImage("3.gif");
player_image[3] = toolkit.getImage("4.gif");
player_image[4] = toolkit.getImage("5.gif");
player_image[5] = toolkit.getImage("6.gif");
player_image[6] = toolkit.getImage("7.gif");
player_image[7] = toolkit.getImage("8.gif");


add("Center", SC);
	}

public boolean handleEvent(Event e)
	{
	if (e.id == Event.WINDOW_DESTROY)
		{
			System.exit(0);
		}
		return super.handleEvent(e);
	}

public void setVisible(boolean b)
   {
      if(b)
      {
         Dimension bounds = toolkit.getDefaultToolkit().getScreenSize();
         Rectangle abounds = getBounds();

         setLocation((bounds.width - abounds.width)/ 2, (bounds.height - abounds.height)/2);
      }
      super.setVisible(b);
   }

public boolean action(Event evt, Object arg)      {

      if (arg.equals("ok"))
       {
         hide();
         return false;
       } else
      return false;
      }


public static void main(String[] args)
	{

    net_mode = args[0];
    net_ip = args[1];
    net_port = args[2];
		f = new spriteview();
		f.setSize(window_bounds_x, window_bounds_y);
		f.setVisible(true);

	}



public class SpriteCanvas extends Canvas
{
spriteview s;
Thread T;
PlayerActor player_icon;
NetPlayerActor net_player_icon;
SpriteClock sc;
boolean connected = false;
NetComm Net;
Graphics offGraphics;
Image offImage;
Dimension offDimension;

public SpriteCanvas(spriteview in)
{
s = in;
player_icon = new PlayerActor(s, this);
player_icon.start();
Net = new NetComm(this, s.net_mode, s.net_ip, s.net_port);
Net.start();
repaint();
//startclock();
sc = new SpriteClock(this);

sc.start();
}

public void connected(boolean in)
{
connected = in;
	if (in)
	{
	net_player_icon = new NetPlayerActor(s, this);
	player_icon.start();
	}
}

public void startclock()
{
//T =  new Thread(this);
//T.start();

	
}

public void paint(Graphics g)
{
update(g);
}

public void update(Graphics g)
{
if (!s.loadedgraphics)
{
	for(int i = 0; i < 8 ; i++)
	{
		g.drawImage(player_image[i],(i*15)+5, 25,this);
	}
 s.loadedgraphics = true;
}
Dimension d = size();

//Create the offscreen graphics context, if no good one exists.
        if ((offGraphics == null) || (d.width != offDimension.width) || (d.height != offDimension.height))
           { offDimension = d;
             offImage = createImage(d.width, d.height);
             offGraphics = offImage.getGraphics();
           }
        //Erase the previous image.
        offGraphics.setColor(getBackground());
        offGraphics.fillRect(0, 0, d.width, d.height);
        offGraphics.setColor(new Color(255,226,197));


  player_icon.paint(offGraphics);

if (connected)
net_player_icon.paint(offGraphics);
//g.drawImage(player_image[facing -1], pos_x, pos_y, this);
g.drawImage(offImage, 0, 0, this);
}

public boolean keyDown(Event e, int key)
 {
 	 sc.keyDown(e, key);
	 return true;
 }


}


public class SpriteClock extends Thread
{
SpriteCanvas sc;
boolean animated = true;

public SpriteClock(SpriteCanvas in)
{
sc = in;
}

public void run()
{
  while(sc.s.game)
		{
			try{Thread.currentThread().sleep(sc.s.FPS);}
			catch(Exception e){System.out.println(e);}
			sc.repaint();
      animated = false;

		}
}

public boolean keyDown(Event e, int key)
           {
String dir = "";

if (!animated)
     {

  if (key == 1005) // DOWN ARROW
              {
						 sc.player_icon.move("DOWN");
dir = "DOWN";
              }else
 if (key == 1007) // DOWN ARROW
              {
              sc.player_icon.move("RIGHT");
dir = "RIGHT";
               }else
 if (key == 1006) // DOWN ARROW
              {
							sc.player_icon.move("LEFT");
dir = "LEFT";
               }else
 if (key == 1004) // DOWN ARROW
              {
  						sc.player_icon.move("UP");
dir = "UP";
               }
            //System.out.println("move");
if (sc.connected)
{
sc.Net.sendMove(sc.s.pos_x, sc.s.pos_y, dir);
}
	}
return true;
}

}

public class PlayerActor extends Thread
{
SpriteCanvas s;
spriteview sv;
//Graphics G;
    /*
public void run()
{

}
      */
public PlayerActor(spriteview in, SpriteCanvas in2)
{
sv = in;
s = in2;
}

public void move(String stin)
{

if (stin.compareTo("DOWN") == 0)
{

if (sv.facing == 2)
sv.facing = 1;
else
sv.facing = 2;

sv.pos_y+=2;


}

else if (stin.compareTo("RIGHT") == 0)
{

	if (sv.facing == 4)
	sv.facing = 3;
	else
	sv.facing = 4;

	sv.pos_x+=2;


}
else if (stin.compareTo("LEFT") == 0)
{

if (sv.facing == 6)
sv.facing = 5;
else
sv.facing = 6;

sv.pos_x-=2;

}
else if (stin.compareTo("UP") == 0)
{

	if (sv.facing == 8)
	sv.facing = 7;
	else
	sv.facing = 8;

	sv.pos_y-=2;

}


} //end move

public void paint(Graphics g)
{
g.drawImage(sv.player_image[sv.facing - 1], sv.pos_x, sv.pos_y, s);
}

}

public class NetPlayerActor extends Thread
{
SpriteCanvas s;
spriteview sv;
int facing = 1;
int pos_x, pos_y;

public void run()
{

}

public NetPlayerActor(spriteview in, SpriteCanvas in2)
{
sv = in;
s = in2;
}

public void updateMoves(int x, int y)
{
if (pos_x != x)
{pos_x = x;}
if (pos_y != y)
{pos_y = y;}
}

public void move(int x, int y, String stin)
{
//System.out.println("move: "+x+"-"+y+"-"+stin);


if (stin.compareTo("DOWN") == 0)
{

if (facing == 2)
facing = 1;
else
facing = 2;

pos_y+=2;


}

else if (stin.compareTo("RIGHT") == 0)
{

	if (facing == 4)
	facing = 3;
	else
	facing = 4;

	pos_x+=2;


}
else if (stin.compareTo("LEFT") == 0)
{

if (facing == 6)
facing = 5;
else
facing = 6;

pos_x-=2;

}
else if (stin.compareTo("UP") == 0)
{

	if (facing == 8)
	facing = 7;
	else
	facing = 8;

	pos_y-=2;

}

updateMoves(x, y);
} //end move

public void paint(Graphics g)
{
g.drawImage(sv.player_image[facing - 1], pos_x, pos_y, s);
}

} //end NetPlayerActor


public class NetComm extends Thread
{
//datastream and socket vars
SpriteCanvas sc;
DataInputStream in;
PrintStream out;
Socket s;
ServerSocket ss;
String ipaddr;
int port;
String mode;

	public NetComm(SpriteCanvas scin, String net_mode, String ip, String portin)
	{
	//contruct ip's a port...etc
		try
		{
		port = Integer.valueOf(portin).intValue();
    ipaddr = ip;
    sc = scin;
    mode = net_mode;
		}
		catch(Exception e){System.out.println("NetComm: "+e);}
	}

	public void run()
	{
			if (mode.compareTo("Server") == 0)
				Server();
			else
				Client();
	}

	public void Client()
	{
     try{
					s = new Socket(ipaddr, port);
			    in = new DataInputStream(s.getInputStream());
      	  out = new PrintStream(s.getOutputStream());
					sc.connected(true);
					String str;
				 while ((str = in.readLine()) != null)
              {
								  decodeData(str);
							}
				}
				catch(Exception ex)
				{
				 System.out.println("Error from Client(): "+ex);
				}

	}

	public void Server()
	{
    try{
				ss = new ServerSocket(port);
				System.out.println("Opening socket "+port);
        s = ss.accept();
        in = new DataInputStream(s.getInputStream());
        out = new PrintStream(s.getOutputStream());
				sc.connected(true);
				String str;
				 while ((str = in.readLine()) != null)
              {
								  decodeData(str);
							}
			}
			catch(Exception ex)
			{
				 System.out.println("Error from Server(): "+ex);
			}
	}

	public void sendMove(int x, int y, String direction)
	{
		out.println(x+","+y+","+direction);
	}

	public void decodeData(String data)
	{
   StringTokenizer ST = new StringTokenizer(data, ",");
 //  System.out.println("decode: "+data);

	
			try {		
				sc.net_player_icon.move(Integer.valueOf(ST.nextToken()).intValue(), Integer.valueOf(ST.nextToken()).intValue(), ST.nextToken());
					}
			catch(Exception e){System.out.println("Error: #decodeData()# "+e);}
	}
	

}  //end NetComm



}//end all










